/*
*  This script defines functions used by Options window
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

//If dialog window is the window to select folder modify the default design.
var dialogID = document.getElementById("newBookmarkDialog");
if(dialogID){
    StartupCustomized();
    /*TODO increase tree's height
    var gBookmarksTree = document.getElementById("bookmarks-view");
    var originalTreeHeight = gBookmarksTree.getAttribute("height");
    //dialogID.style="width: 36em; height: 180em;";
    gBookmarksTree.setAttribute("height", originalTreeHeight*2);
    */
}


//Function used to customize addBookmark.xul to achieve our needs: select folder design
function StartupCustomized(){
    var movetoLabel = document.getElementById("movetolabel");//.setAttribute("hidden", "true");
    var labelValue = Bookmarkdd.searchStringLocalisation("Options.SelectFolder.label");
    var newLabel = document.createElement("label");
    newLabel.setAttribute("value",labelValue);
    document.getElementById("movetolabel").parentNode.replaceChild(newLabel, movetoLabel);

    var buttonNewFolder = dialogID.getElementsByAttribute("oncommand","createNewFolder();")
    buttonNewFolder[0].hidden = true;

}

// Select folder
function selectFolder(){
    var rv = { selectedFolder: null };      
    openDialog("chrome://browser/content/bookmarks/addBookmark.xul", "", 
               "centerscreen,chrome,modal=yes,dialog=yes,resizable=yes", null, 
               null, null, null, "selectFolder", rv);
    if (!rv.target) return; //If no folder is selected abort
    var targetResource = rv.target.parent;
    var targetName = BookmarksUtils.getProperty(targetResource.Value,gNCNS+"Name");
    var targetPath = Bookmarkdd.findPath(targetResource);

    //WARNING message: selection of root Folder 'Bookmarks' will delete ONLY duplicates which aren't in subfolders.
    //If you want to modify separator ' > ' you need to also modify it in ManageDuplicates.js
    var targetFolder = "";
    if(targetPath){
	targetFolder = targetPath+" > "+targetName;
    } else {
	targetFolder = targetName;
	//var warning = Bookmarkdd.searchStringLocalisation("Options.SelectFolder.Warning");
    	//alert(warning);
    }
	var textBoxFolder = document.getElementById("opt-selected-folder");
	textBoxFolder.value = targetFolder;
	UserPrefs.setPref("string","AutoDelete.SelectedFolder",targetFolder);

}


// enable / disable folder field and button
function VerifyFolderStatus(){
    var checkBox = document.getElementById("opt-AutoDelete.BookmarkInSelectedFolder");
    if (checkBox.checked) {
	document.getElementById("opt-selected-folder").disabled = false;
	document.getElementById("select-folder").disabled = false;
    } else {
	document.getElementById("opt-selected-folder").disabled = true;
	document.getElementById("select-folder").disabled = true;
    }
}



function OptionsOnLoad(){
    VerifyFolderStatus();

    const ADD_BOOKMARK_HERE_ID = "{F33233B3-EDB1-41f4-8482-917AB190E647}";
    var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
			    .getService(Components.interfaces.nsIExtensionManager);
    var addBookmarkHere = extensionManager.getItemForID(ADD_BOOKMARK_HERE_ID);
    if (addBookmarkHere.version){
	var messageText = Bookmarkdd.searchStringLocalisation("Options.Miscellaneous.AddBookmarkHere.Info");
	var messageParent = document.getElementById("addBookmarkHere-information");
	var messageParagraphs = messageText.split("\n");

	for (var i = 0; i < messageParagraphs.length; i++) {
	    var descriptionNode = document.createElement("description");
	    var text = document.createTextNode(messageParagraphs[i]);
	    descriptionNode.appendChild(text);
	    messageParent.appendChild(descriptionNode);
	}
    } else {
	document.getElementById("opt-miscellaneous.addBookmarkHere").disabled = true;
    }

}
